% boxReady
%   Prepares the axes for the zoom select box.  The Zoom In
%   button sets boxReady as the "ButtonDownFcn" of the axes.

function boxReadyCS(axHandle,handles);

    handles.CurrentPoint = get(axHandle,'CurrentPoint');
    set(handles.CarSim,'PointerShapeCData',handles.MagnifyingGlass);

    set(axHandle,'NextPlot','add');

    if ishandle(handles.dragBox)
        delete(handles.dragBox);
    end

    handles.dragBox = patch(axHandle,repmat(handles.CurrentPoint(1,1),[1 4]),repmat(handles.CurrentPoint(1,2),[1 4]));
    set(handles.dragBox,'FaceColor','none','EdgeColor','r','LineStyle',':');
    set(axHandle,'NextPlot','replace');

    handles.zoomedaxlims = [get(axHandle,'XLim') get(axHandle,'YLim')];

    % The window button motion function to set the pointer


    guidata(axHandle,handles);

    set(handles.CarSim,'Units','pixels','WindowButtonMotionFcn',...
        ['handles = guidata(gcbo);'...
        'drawBoxCS(handles.dragBox,handles.CurrentPoint,handles.zoomedaxlims,get(gca,''CurrentPoint''));'],...
        'WindowButtonUpFcn',...
        ['handles = guidata(gcbo); set(gcf,''WindowButtonMotionFcn'',''CarSim(''''ZoomPointerControlBlk'''',gcbo);'',''WindowButtonUpFcn'','''');'...
        'ptr.XYLim = [get(handles.dragBox,''Xdata'') get(handles.dragBox,''YData'')];,'...
        'set(gcf,''Units'',''Normalized''); delete(handles.dragBox);'...
        'if numel(ptr.XYLim) >=4 && ~any(any(isnan(ptr.XYLim)))'...
            'diffLim = diff(ptr.XYLim); diffAx = diff(handles.axlims);'...
            'if diffLim(2,1) > diffAx(1)/100 && diffLim(1,2) > diffAx(3)/100 '...
                'try,'...
                'set(gca,''XLim'',[ptr.XYLim(1,1) ptr.XYLim(3,1)],''YLim'',[ptr.XYLim(1,2) ptr.XYLim(3,2)]);'...
                'end,'...
            'end,'...
            'clear diffLim diffAx;'...
         'end,'...
         'handles.zoomedaxlims = [get(gca,''XLim'') get(gca,''YLim'')];'...
         'guidata(gcbo,handles); clear ptr;'...
          ]);
