% getlsim() - A MATLAB based application used to input system state space model.
% This application makes extensive use of the GUI capabilities
% of Matlab R12. 
%
%  Farid Golnaraghi 1993, 1999-2002
% The MechWorks Software Inc., Waterloo, Ont., Canada
% Version (2007.5.11) - Michael Ages 
% Last Modified: 07/03/2007
%=============================================================
t0=0;
tstep=0.01;
tsim=5;
vabls.tset=[];
vabls.numinput=[];
input='sin(t)';

LSIMWIND=figure('Units','Normal','Position',[0.15 0.35 .35 .35],...
			'color',LIGHTGREY,'Name','Time Response Window  Farid Golnaraghi & B. Kuo 1993, 1999-2002',...
			'NumberTitle','off','WindowStyle','modal','Resize','Off');
      
%=======Instructions 

h01text={'Enter the start time: '};
h02text={'Enter the stepsize: '};
h03text={'Enter the simulation time: '};
h04text={'Enter the input function, e.g. sin(t) or exp(-t): '};

h0(1)=uicontrol(LSIMWIND,'Style','Text','Units','Normal', ...
	'Foreground',TITLFORE,'Background',LIGHTGREY,...
	'Position',[0.1*BOX1_W  18.5*BOX1_H 9*BOX1_W BOX1_H], ...
	'String',h01text,'Fontsize',10,'FontWeight','Bold');

h0(2)=uicontrol(LSIMWIND,'Style','Text','Units','Normal', ...
	'Foreground',TITLFORE,'Background',LIGHTGREY,...
	'Position',[0.1*BOX1_W  15*BOX1_H 9*BOX1_W BOX1_H], ...
	'String',h02text,'Fontsize',10,'FontWeight','Bold');

h0(3)=uicontrol(LSIMWIND,'Style','Text','Units','Normal', ...
	'Foreground',TITLFORE,'Background',LIGHTGREY,...
	'Position',[0.1*BOX1_W  11.5*BOX1_H 9*BOX1_W BOX1_H], ...
	'String',h03text,'Fontsize',10,'FontWeight','Bold');

h0(4)=uicontrol(LSIMWIND,'Style','Text','Units','Normal', ...
	'Foreground',TITLFORE,'Background',LIGHTGREY,...
	'Position',[0.4*BOX1_W  7.75*BOX1_H 9*BOX1_W BOX1_H], ...
	'String',h04text,'Fontsize',10,'FontWeight','bold');



%=================Input column===================

guiele.h(1,2)=uicontrol(LSIMWIND,'Style','Edit','Units','Normal', ...
	'Foreground',BLACK,'Background',TEDITBAK,...
	'Position',[2.0*BOX1_W  16.5*BOX1_H 5.50*BOX1_W 1.5*BOX1_H], ...
	'String',num2str(t0),'Fontsize',10,'FontWeight','Demi','keypressfcn','eval(cnstn.StateOtherInputsEnterPress);');

guiele.h(2,2)=uicontrol(LSIMWIND,'Style','Edit','Units','Normal', ...
	'Foreground',BLACK,'Background',TEDITBAK,...
	'Position',[2.0*BOX1_W  13*BOX1_H 5.50*BOX1_W 1.5*BOX1_H], ...
	'String',num2str(tstep),'Fontsize',10,'FontWeight','Demi','keypressfcn','eval(cnstn.StateOtherInputsEnterPress);');

guiele.h(3,2)=uicontrol(LSIMWIND,'Style','Edit','Units','Normal', ...
	'Foreground',BLACK,'Background',TEDITBAK,...
	'Position',[2.0*BOX1_W  9.5*BOX1_H 5.50*BOX1_W 1.5*BOX1_H], ...
	'String',num2str(tsim),'Fontsize',10,'FontWeight','Demi','keypressfcn','eval(cnstn.StateOtherInputsEnterPress);');

guiele.h(4,2)=uicontrol(LSIMWIND,'Style','Edit','Units','Normal', ...
	'Foreground',BLACK,'Background',TEDITBAK,...
	'Position',[2.0*BOX1_W  5.5*BOX1_H 5.50*BOX1_W 1.5*BOX1_H], ...
	'String',num2str(input),'Fontsize',10,'FontWeight','Demi','keypressfcn','eval(cnstn.StateOtherInputsEnterPress);');

cnstn.StateOtherInputsEnterPress=[... %this is the keypressfcn for the four edit boxes created above.
                            'if double(get(LSIMWIND,''currentcharacter'')) == 13;',...
                            '  eval(get(h_plot,''callback''));',...
                            'end;',...
                            ];

% ====================plot button========================================
h_plot=uicontrol(LSIMWIND,'Style','PushButton','Units','Normal',...
   'Position',[3.50*BOX1_W  2.5*BOX1_H 3.00*BOX1_W 2*BOX1_H],...
   'String',' PLOT ','Fontsize',10,'FontWeight','Bold',...
	'CallBack',[...
       'set(LSIMWIND,''pointer'',''watch'');',...
       'drawnow;',...
       'clear t0,ts0=[];t0=str2num(char(get(guiele.h(1,2),''String'')));',...
       'clear tstep,tstep=[];tstep=str2num(char(get(guiele.h(2,2),''String'')));',...
       'clear tsim,tsim=[];tsim=str2num(char(get(guiele.h(3,2),''String'')));',...
       'clear input,input=[];input=char(get(guiele.h(4,2),''String''));',...
       'syms t;vabls.tset=[t0:tstep:tsim];vabls.numinput=subs(input,t,vabls.tset);',...
       'figure(''Units'',''Normal'',''Name'',''Time Response'',''position'',[1.25*BOX2_W 0 0.75 0.8]),',...
       'lsim(Statemodel,vabls.numinput,vabls.tset),xlabel(''Time (sec)''),ylabel(''Amplitude''),title(''Time Response''),',...
       'set(LSIMWIND,''pointer'',''arrow'');',...
       'close(LSIMWIND);',...
    ]);
%============================================== DONE PushButton
h_DONE=uicontrol(LSIMWIND,'Style','PushButton','Units','Normal',...
   'Position',[3.50*BOX1_W  0.75*BOX1_H 3.00*BOX1_W 1.25*BOX1_H],...
   'String',' DONE ','Fontsize',10,'FontWeight','Bold',...
	'CallBack',[...
       'clear tsim,tsim=[];tsim=str2num(char(get(guiele.h(1,2),''String'')));',...
       'clear input,input=[];input=char(get(guiele.h(2,2),''String''));',...
   'clear h h0; close(gcf),',...
    ]);
