    function progmeter(varargin)
        
            % Manages the opening progress meter
            
            persistent fig
            persistent bar
            if nargin == 1
                progress = varargin{1};
                set(bar,'Position',[ 0 0 progress 1]);
            else
                progress = varargin{1};
                command = varargin{2};
                switch command
                    case 'close'
                        close(fig);
                        clear persistent fig bar;
                    case 'open'
                         fig = figure('Menubar','none',...
                                        'Units','Normalized',...
                                        'Name','Loading...',...
                                        'Resize','off',...
                                        'NumberTitle','off',...
                                        'BackingStore','off',...
                                        'Color',[0.9 0.9 0.9],...
                                        'Position',[0.45 0.45 0.1 0.05],...
                                        'Pointer','watch',...
                                        'WindowStyle','modal');
                    
                        set(fig,'Units','pixels');
                        progpos = get(fig,'Position');
                        set(fig,'Position',[progpos(1:2) 200 80]);
                        bar = uipanel('Parent',fig,...
                                            'Units','pixels',...
                                            'BorderType','line',...
                                            'ForegroundColor','k',...
                                            'BorderWidth',2,...
                                            'BackgroundColor',[1 1 1],...
                                            'Position',[10 10 180 60],...
                                            'Title',''...
                                            );
                        bar = uipanel('Parent',bar,...
                                            'Units','normalized',...
                                            'BorderType','none',...
                                            'BackgroundColor','b',...
                                            'Position',[0 0 progress 1],...
                                            'Title',''...
                                            );
                end
            end
            drawnow;